#pragma once
#include <chrono>

namespace spin
{
    class ISleeper
    {
        public:
        virtual ~ISleeper() = default;

        virtual void sleepFor(const std::chrono::milliseconds &duration) = 0;
        virtual void sleepUntil(const std::chrono::time_point<std::chrono::system_clock> &timePoint) = 0;
        virtual void wakeUpAll() = 0;
    };
    
} // namespace spin
